"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _got = _interopRequireDefault(require("got"));

var _http = _interopRequireDefault(require("http"));

var _loglevel = _interopRequireDefault(require("loglevel"));

var _controller = _interopRequireDefault(require("./controller"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (functions, port, apiName) => {
  const server = _http.default.createServer();

  const controller = (0, _controller.default)(_got.default, functions);
  const endpoints = functions.map(({
    method,
    path
  }) => ({
    method: method.toUpperCase(),
    path: path.full
  }));
  server.on('request', controller);
  server.listen(port, () => {
    _loglevel.default.info(`Server is running on port ${port}`);

    _loglevel.default.info('The following endpoints are exposed:');

    if (_loglevel.default.getLevel() <= _loglevel.default.levels.INFO) {
      console.table(endpoints);
    }

    const teardownCommand = `sam-proxy teardown ${apiName}`;

    _loglevel.default.info(`For removing all containers generated by this script, run the following command - "${teardownCommand}"`);
  });
};

exports.default = _default;